##// END OF EJS Templates
buildrpm: bump bundled Python version to 2.7.16 when building for centos{5,6}...
Antonio Muci -
r42378:ae68418c stable
parent child Browse files
Show More
@@ -1,76 +1,76
1 PYTHONVER=2.7.14
1 PYTHONVER=2.7.16
2 2 PYTHONNAME=python-
3 3 PREFIX=$(HOME)/bin/prefix-$(PYTHONNAME)$(PYTHONVER)
4 4 SYMLINKDIR=$(HOME)/bin
5 5
6 6 help:
7 7 @echo
8 8 @echo 'Make a custom installation of a Python version'
9 9 @echo
10 10 @echo 'Common make parameters:'
11 11 @echo ' PYTHONVER=... [$(PYTHONVER)]'
12 12 @echo ' PREFIX=... [$(PREFIX)]'
13 13 @echo ' SYMLINKDIR=... [$(SYMLINKDIR) creating $(PYTHONNAME)$(PYTHONVER)]'
14 14 @echo
15 15 @echo 'Common make targets:'
16 16 @echo ' python - install Python $$PYTHONVER in $$PREFIX'
17 17 @echo ' symlink - create a $$SYMLINKDIR/$(PYTHONNAME)$$PYTHONVER symlink'
18 18 @echo
19 19 @echo 'Example: create a temporary Python installation:'
20 20 @echo ' $$ make -f Makefile.python python PYTHONVER=${PYTHONVER} PREFIX=/tmp/p27'
21 21 @echo ' $$ /tmp/p27/bin/python -V'
22 22 @echo ' Python 2.7'
23 23 @echo
24 24 @echo 'Some external libraries are required for building Python: zlib bzip2 openssl.'
25 25 @echo 'Make sure their development packages are installed systemwide.'
26 26 # fedora: yum install zlib-devel bzip2-devel openssl-devel
27 27 # debian: apt-get install zlib1g-dev libbz2-dev libssl-dev
28 28 @echo
29 29 @echo 'To build a nice collection of interesting Python versions:'
30 30 @echo ' $$ for v in 2.{6{,.1,.2,.9},7{,.8,.10}}; do'
31 31 @echo ' make -f Makefile.python symlink PYTHONVER=$$v || break; done'
32 32 @echo 'To run a Mercurial test on all these Python versions:'
33 33 @echo ' $$ for py in `cd ~/bin && ls $(PYTHONNAME)2.*`; do'
34 34 @echo ' echo $$py; $$py run-tests.py test-http.t; echo; done'
35 35 @echo
36 36
37 37 export LANGUAGE=C
38 38 export LC_ALL=C
39 39
40 40 python: $(PREFIX)/bin/python docutils
41 41 printf 'import sys, zlib, bz2, docutils, ssl' | $(PREFIX)/bin/python
42 42
43 43 PYTHON_SRCDIR=Python-$(PYTHONVER)
44 44 PYTHON_SRCFILE=$(PYTHON_SRCDIR).tgz
45 45
46 46 $(PREFIX)/bin/python:
47 47 [ -f $(PYTHON_SRCFILE) ] || wget http://www.python.org/ftp/python/$(PYTHONVER)/$(PYTHON_SRCFILE) || curl -OL http://www.python.org/ftp/python/$(PYTHONVER)/$(PYTHON_SRCFILE) || [ -f $(PYTHON_SRCFILE) ]
48 48 rm -rf $(PYTHON_SRCDIR)
49 49 tar xf $(PYTHON_SRCFILE)
50 50 # Debian/Ubuntu disables SSLv2,3 the hard way, disable it on old Pythons too
51 51 -sed -i 's,self.*SSLv[23]_method(),0;//\0,g' $(PYTHON_SRCDIR)/Modules/_ssl.c
52 52 # Find multiarch system libraries on Ubuntu and disable fortify error when setting argv
53 53 LDFLAGS="-L/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH`"; \
54 54 BASECFLAGS=-U_FORTIFY_SOURCE; \
55 55 export LDFLAGS BASECFLAGS; \
56 56 cd $(PYTHON_SRCDIR) && ./configure --prefix=$(PREFIX) && make all SVNVERSION=pwd && make install
57 57 printf 'import sys, zlib, bz2, ssl' | $(PREFIX)/bin/python
58 58 rm -rf $(PYTHON_SRCDIR)
59 59
60 60 DOCUTILSVER=0.12
61 61 DOCUTILS_SRCDIR=docutils-$(DOCUTILSVER)
62 62 DOCUTILS_SRCFILE=$(DOCUTILS_SRCDIR).tar.gz
63 63
64 64 docutils: $(PREFIX)/bin/python
65 65 @$(PREFIX)/bin/python -c 'import docutils' || ( set -ex; \
66 66 [ -f $(DOCUTILS_SRCFILE) ] || wget http://downloads.sourceforge.net/project/docutils/docutils/$(DOCUTILSVER)/$(DOCUTILS_SRCFILE) || [ -f $(DOCUTILS_SRCFILE) ]; \
67 67 rm -rf $(DOCUTILS_SRCDIR); \
68 68 tar xf $(DOCUTILS_SRCFILE); \
69 69 cd $(DOCUTILS_SRCDIR) && $(PREFIX)/bin/python setup.py install --prefix=$(PREFIX); \
70 70 $(PREFIX)/bin/python -c 'import docutils'; \
71 71 rm -rf $(DOCUTILS_SRCDIR); )
72 72
73 73 symlink: python $(SYMLINKDIR)
74 74 ln -sf $(PREFIX)/bin/python $(SYMLINKDIR)/$(PYTHONNAME)$(PYTHONVER)
75 75
76 76 .PHONY: help python docutils symlink
@@ -1,160 +1,160
1 1 #!/bin/bash -e
2 2 #
3 3 # Build a Mercurial RPM from the current repo
4 4 #
5 5 # Tested on
6 6 # - Fedora 20
7 7 # - CentOS 5
8 8 # - centOS 6
9 9
10 10 . $(dirname $0)/packagelib.sh
11 11
12 12 BUILD=1
13 13 RPMBUILDDIR="$PWD/rpmbuild"
14 14
15 15 while [ "$1" ]; do
16 16 case "$1" in
17 17 --prepare )
18 18 shift
19 19 BUILD=
20 20 ;;
21 21 --withpython | --with-python)
22 22 shift
23 PYTHONVER=2.7.14
24 PYTHONMD5=cee2e4b33ad3750da77b2e85f2f8b724
23 PYTHONVER=2.7.16
24 PYTHONMD5=f1a2ace631068444831d01485466ece0
25 25 ;;
26 26 --rpmbuilddir )
27 27 shift
28 28 RPMBUILDDIR="$1"
29 29 shift
30 30 ;;
31 31 * )
32 32 echo "Invalid parameter $1!" 1>&2
33 33 exit 1
34 34 ;;
35 35 esac
36 36 done
37 37
38 38 cd "`dirname $0`/../.."
39 39
40 40 specfile=$PWD/contrib/packaging/mercurial.spec
41 41 if [ ! -f $specfile ]; then
42 42 echo "Cannot find $specfile!" 1>&2
43 43 exit 1
44 44 fi
45 45
46 46 if [ ! -d .hg ]; then
47 47 echo 'You are not inside a Mercurial repository!' 1>&2
48 48 exit 1
49 49 fi
50 50
51 51 gethgversion
52 52
53 53 if [ -z "$type" ] ; then
54 54 release=1
55 55 else
56 56 release=0.9_$type
57 57 fi
58 58
59 59 if [ -n "$distance" ] ; then
60 60 release=$release+${distance}_${node}
61 61 fi
62 62
63 63 if [ "$PYTHONVER" ]; then
64 64 release=$release+$PYTHONVER
65 65 RPMPYTHONVER=$PYTHONVER
66 66 else
67 67 RPMPYTHONVER=%{nil}
68 68 fi
69 69
70 70 mkdir -p $RPMBUILDDIR/{SOURCES,BUILD,SRPMS,RPMS}
71 71 $HG archive -t tgz $RPMBUILDDIR/SOURCES/mercurial-$version-$release.tar.gz
72 72 if [ "$PYTHONVER" ]; then
73 73 (
74 74 mkdir -p build
75 75 cd build
76 76 PYTHON_SRCFILE=Python-$PYTHONVER.tgz
77 77 [ -f $PYTHON_SRCFILE ] || curl -Lo $PYTHON_SRCFILE http://www.python.org/ftp/python/$PYTHONVER/$PYTHON_SRCFILE
78 78 if [ "$PYTHONMD5" ]; then
79 79 echo "$PYTHONMD5 $PYTHON_SRCFILE" | md5sum -w -c
80 80 fi
81 81 ln -f $PYTHON_SRCFILE $RPMBUILDDIR/SOURCES/$PYTHON_SRCFILE
82 82
83 83 DOCUTILSVER=`sed -ne "s/^%global docutilsname docutils-//p" $specfile`
84 84 DOCUTILS_SRCFILE=docutils-$DOCUTILSVER.tar.gz
85 85 [ -f $DOCUTILS_SRCFILE ] || curl -Lo $DOCUTILS_SRCFILE http://downloads.sourceforge.net/project/docutils/docutils/$DOCUTILSVER/$DOCUTILS_SRCFILE
86 86 DOCUTILSMD5=`sed -ne "s/^%global docutilsmd5 //p" $specfile`
87 87 if [ "$DOCUTILSMD5" ]; then
88 88 echo "$DOCUTILSMD5 $DOCUTILS_SRCFILE" | md5sum -w -c
89 89 fi
90 90 ln -f $DOCUTILS_SRCFILE $RPMBUILDDIR/SOURCES/$DOCUTILS_SRCFILE
91 91 )
92 92 fi
93 93
94 94 mkdir -p $RPMBUILDDIR/SPECS
95 95 rpmspec=$RPMBUILDDIR/SPECS/mercurial.spec
96 96
97 97 sed -e "s,^Version:.*,Version: $version," \
98 98 -e "s,^Release:.*,Release: $release," \
99 99 $specfile > $rpmspec
100 100
101 101 echo >> $rpmspec
102 102 echo "%changelog" >> $rpmspec
103 103
104 104 if echo $version | grep '+' > /dev/null 2>&1; then
105 105 latesttag="`echo $version | sed -e 's/+.*//'`"
106 106 $HG log -r .:"$latesttag" -fM \
107 107 --template '{date|hgdate}\t{author}\t{desc|firstline}\n' | python -c '
108 108 import sys, time
109 109
110 110 def datestr(date, format):
111 111 return time.strftime(format, time.gmtime(float(date[0]) - date[1]))
112 112
113 113 changelog = []
114 114 for l in sys.stdin.readlines():
115 115 tok = l.split("\t")
116 116 hgdate = tuple(int(v) for v in tok[0].split())
117 117 changelog.append((datestr(hgdate, "%F"), tok[1], hgdate, tok[2]))
118 118 prevtitle = ""
119 119 for l in sorted(changelog, reverse=True):
120 120 title = "* %s %s" % (datestr(l[2], "%a %b %d %Y"), l[1])
121 121 if prevtitle != title:
122 122 prevtitle = title
123 123 print
124 124 print title
125 125 print "- %s" % l[3].strip()
126 126 ' >> $rpmspec
127 127
128 128 else
129 129
130 130 $HG log \
131 131 --template '{date|hgdate}\t{author}\t{desc|firstline}\n' \
132 132 .hgtags | python -c '
133 133 import sys, time
134 134
135 135 def datestr(date, format):
136 136 return time.strftime(format, time.gmtime(float(date[0]) - date[1]))
137 137
138 138 for l in sys.stdin.readlines():
139 139 tok = l.split("\t")
140 140 hgdate = tuple(int(v) for v in tok[0].split())
141 141 print "* %s %s\n- %s" % (datestr(hgdate, "%a %b %d %Y"), tok[1], tok[2])
142 142 ' >> $rpmspec
143 143
144 144 fi
145 145
146 146 sed -i \
147 147 -e "s/^%define withpython.*$/%define withpython $RPMPYTHONVER/" \
148 148 $rpmspec
149 149
150 150 if [ "$BUILD" ]; then
151 151 rpmbuild --define "_topdir $RPMBUILDDIR" -ba $rpmspec --clean
152 152 if [ $? = 0 ]; then
153 153 echo
154 154 echo "Built packages for $version-$release:"
155 155 find $RPMBUILDDIR/*RPMS/ -type f -newer $rpmspec
156 156 fi
157 157 else
158 158 echo "Prepared sources for $version-$release $rpmspec are in $RPMBUILDDIR/SOURCES/ - use like:"
159 159 echo "rpmbuild --define '_topdir $RPMBUILDDIR' -ba $rpmspec --clean"
160 160 fi
General Comments 0
You need to be logged in to leave comments. Login now